!
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
! 
program main
  integer,parameter:: nfin = 10, nfout = 11
  real(kind=8),parameter:: oneau = 0.529177249
  integer:: nrx2, nry2, nrz2
  real(kind=8):: aa(3,3)
  character(len=256):: ifname, ofname, name, argv(4)
  integer:: ios
  logical:: error
  integer:: iorg(3)
  real(kind=8),allocatable:: field(:,:,:,:)
  character(len=8),parameter:: magic = 'TAPP:rho'
  character(len=8):: sign
  integer:: ic, i
  logical:: multiq, nextq
  character(len=256):: acount
  integer:: nspin, is

  ic = 1
  multiq = .false.
  call getarg(ic, argv(ic))
  if ( argv(ic) .eq. '-m' ) then
     multiq = .true.
     ic = ic + 1
  end if
  call getarg(ic, argv(ic))
  if (len_trim(argv(ic)) .eq. 0) then
     write(6,*) 'invalid fname'
     stop
  end if
  ifname = argv(ic)
  open(nfin, file=ifname, status='old', action='read', form='unformatted')
  ic = ic + 1
  do i = ic, ic + 2
     call getarg(i, argv(i))
  end do
  read(argv(ic),*,iostat=ios) iorg(1)
  if (ios .eq. 0) then
     error = .false.
     read(argv(ic+1),*,iostat=ios) iorg(2)
     error = error .or. (ios .ne. 0)
     read(argv(ic+2),*,iostat=ios) iorg(3)
     error = error .or. (ios .ne. 0)
     if (error) then
        write(6,*) 'invalid position of origin'
        stop
     end if
  else
     iorg(1) = 0
     iorg(2) = 0
     iorg(3) = 0
  end if

  rewind nfin
  if (multiq) then
     ic = 1
  end if
  read(nfin) sign
  if (sign .ne. magic) then
     write(6,*) 'bad magic: ', sign
     stop
  end if
  nextq = .true.
  do while (nextq)
     read(nfin) aa, nspin
     read(nfin) nrx2, nry2, nrz2
     allocate(field(nrx2,nry2,nrz2,nspin))
     read(nfin) field

     if (multiq) then
        write(acount, '(''.'',i3.3)') ic
        ofname=trim(ifname)//trim(acount)//'.dx'//achar(0)
     else
        ofname=trim(ifname)//'.dx'//achar(0)
     end if
     name='TAPP rho'//achar(0)
     call outfldpr(ofname, name, nrx2, nry2, nrz2, aa, iorg, nspin, &
          nrx2, nry2, nrz2, field, 0)
     deallocate(field)

     if (.not. multiq) then
        exit
     end if

     read(nfin, iostat=ios) sign
     if (ios .ne. 0) then
        nextq = .false.
     else if (sign .ne. magic) then
        write(6,*) 'bad magic: ', sign
        stop
     end if
     ic = ic + 1
  end do
  stop
end program main
