!
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
! 
program main
  integer,parameter:: nfin = 10, nfout = 11
  real(kind=8),parameter:: oneau = 0.529177249
  character(len=*),parameter:: magic = 'stm file'
  integer:: nspin, nrx, nry, nrz
  real(kind=8):: aa(3,3)
  real(kind=4):: delta(3,3)
  real(kind=8),allocatable:: field(:,:,:,:),bias(:)
  character(len=8):: buf

  integer:: i,j,k,is,nbias,ibias,oid,oiddat(2)
  integer,allocatable:: oidstm(:)

  rewind nfin
  read(nfin) buf
  if (buf .ne. magic) then
     write(7,*)'bad magic'
     stop
  endif
  read(nfin) aa, nspin
  read(nfin) nrx, nry, nrz
  allocate(field(nrx*2,nry*2,nrz*2,nspin))
  read(nfin) nbias
  allocate(bias(nbias),oidstm(nbias))

  write(nfout, &
       '("object 1 class gridpositions counts", i5, " ", i5, " ", i5)') &
       nrx*2, nry*2, nrz*2
  write(nfout, '(a)') 'origin 0.0 0.0 0.0'
  delta(:,1) = oneau*aa(:,1)/(2*nrx)
  delta(:,2) = oneau*aa(:,2)/(2*nry)
  delta(:,3) = oneau*aa(:,3)/(2*nrz)
  write(nfout,'("delta ", e16.8, " ", e16.8, " ", e16.8)') &
       delta(1,1), delta(2,1), delta(3,1)
  write(nfout,'("delta ", e16.8, " ", e16.8, " ", e16.8)') &
       delta(1,2), delta(2,2), delta(3,2)
  write(nfout,'("delta ", e16.8, " ", e16.8, " ", e16.8)') &
       delta(1,3), delta(2,3), delta(3,3)
  write(nfout, &
       '("object 2 class gridconnections counts", i5, " ", i5, " ", i5)') &
       nrx*2, nry*2, nrz*2

  oid = 3
  do ibias = 1, nbias
     read(nfin) bias(ibias), field
     do is=1,nspin
        write(nfout,'("object ", i3, " class array type float rank 0")') oid
        oiddat(is) = oid
        oid = oid + 1
        write(nfout,'("items ", i9, " data follows")') 8*nrx*nry*nrz
        write(nfout,'(e16.8, " ", e16.8, " ", e16.8, " ", e16.8)') &
             (((real(field(i,j,k,is),4),k=1,2*nrz),j=1,2*nry),i=1,2*nrx)
        write(nfout, '(a)') 'attribute "dep" string "positions"'
     end do

     write(nfout, '("object ", i3, " class field")') oid
     oidstm(ibias) = oid
     oid = oid + 1
     write(nfout, '(a)') 'component "positions" value 1'
     write(nfout, '(a)') 'component "connections" value 2'
     write(nfout, '("component ""data"" value ", i3)') oiddat(1)
     if (nspin .eq. 2) then
        write(nfout, '("component ""auxdat"" value ", i3)') oiddat(2)
     end if
  end do


  write(nfout, '(a)') 'object "TAPP STM" class series'
  do ibias = 1, nbias
     write(nfout, '("member ", i3, " position ", e16.8, " value ", i3)') &
          ibias-1, real(bias(ibias), kind(1.0)), oidstm(ibias)
  end do
  write(nfout, '(a)') 'end'
  close(nfout)

  deallocate(field,bias,oidstm)
  stop
end program main
