!
! Copyright (c) 2000-2013 Yoshihide Yoshimoto
!
module iounit
  implicit none

  integer:: NFCHR
  parameter(NFCHR=25)
  ! to store total CHaRge

  integer:: NFINPUT
  parameter(NFINPUT=10)
  ! input data for parallel program

  integer:: NFLPT
  parameter(NFLPT=11)
  ! to store Local PoTentials

  integer:: NFNSYKZ
  parameter(NFNSYKZ=13)
  ! irreducible real lattice point data.
  ! nsy(oribt): # of lattice point in each orbit.
  ! kz([x,y,z],orbit,operation):
  !   real lattice points classifid under the oribits.

  integer:: NFNWK
  parameter(NFNWK=14)
  ! irreducible FFT mesh point data.
  ! nwk(1:nrxyz,1:3): mesh points grouped into the each orbit.
  !   The order is {1, ..., nwk(1)}, {nwk(1)+1, ..., nwk(1)+nwk(2)}, ...
  ! idcwk(1: # of orbits, 1): index to the head of each orbit in nwk.
  ! idcwk(1: # of orbits, 2): # of mesh points belongs to the orbit.
  ! used in ysymch.

  integer:: NFKF
  parameter(NFKF=15)
  ! aff(nkfxa), kf(3,nkfxa) and ind(nkfxa) (plane wave for local potential)
  ! generated in ggenpw are stored.
  ! ind associates aff with akk.

  integer:: NFRHI1
  parameter(NFRHI1=28)
  ! to store the 1st atomic charge of the pseudo-potential.
  ! remaining atomic charges are assigned to
  ! nfrhi1+1, nfrhi1+2,..,nfrhi1+nad.

  integer:: NFPOT1
  parameter(NFPOT1=34)
  ! to store the 1st pseudo POTential. remaining PPs are
  ! assigned to nfpot1+1, nfpot1+2,..,nfpot1+nad.

  integer:: NFQG
  parameter(NFQG=40)
  ! to store QG(variable name)

  integer:: NFPE
  parameter(NFPE=51)
  ! to store nb1, nb2, nkr, nng, pe, kz, nsy
  !  : cosine fitting data of band. passed to pefcos.

  integer:: NFWFI
  parameter(NFWFI=95)
  ! for Wave Function to Input

  integer:: NFWFO
  parameter(NFWFO=96)
  ! for Wave Function to Output

  integer:: NFRSL
  parameter(NFRSL=99)
  ! to store ReSuLts of optimization

  integer:: NFSAMPK
  parameter(NFSAMPK=21)
  ! sk(sample k point) and rco(\sum_{k in orbit c(sk)}\cos(k\cdot R))
  ! are stored.

  integer:: NFNKMKG
  parameter(NFNKMKG=22)
  ! nkm,kg(3,nkm) generated in vbnlp for each sample
  ! k points are stored in the same order of the sample
  ! k points.

  integer:: NFACGD
  parameter(NFACGD=70)
  ! atom cg data stored. used for chain job.

  integer:: NFLMD
  parameter(NFLMD=71)
  ! linmin data stored. used for chain job.

  integer:: NFSCFD
  parameter(NFSCFD=72)
  ! scf data stored. used for chain job.

  integer:: NFPOTS
  parameter(NFPOTS=73)
  ! atomic potential data stored. used for recycling of the initialization.

  integer:: NFBSPOT
  parameter(NFBSPOT=74)
  ! atomic potential data fitted with B-spline

  integer:: NFMDCNT
  parameter(NFMDCNT=75)
  ! data to continue molecular dynamics

  integer:: NFMDMBMT
  parameter(NFMDMBMT=76)
  ! data for multi-baric multi-thermal MD

  integer:: NFUMBMT
  parameter(NFUMBMT=77)
  ! updated data for multi-baric multi-thermal MD

  integer:: NFSMBMT
  parameter(NFSMBMT=78)
  ! snap data for multi-baric multi-thermal MD

  integer:: NFMDLOG
  parameter(NFMDLOG=16)
  ! log of molecular dynamics

  integer:: NFMDSMPL
  parameter(NFMDSMPL=17)
  ! sampled configurations

  integer:: NFVBCHRGWAV
  parameter(NFVBCHRGWAV=18)

end module iounit
